/***************************************************************************
 *cr
 *cr            (C) Copyright 2010 The Board of Trustees of the
 *cr                        University of Illinois
 *cr                         All Rights Reserved
 *cr
 ***************************************************************************/

// This changes hpvm::DEVICE (backward-compatible hint name) to hpvm::CUDNN_TARGET.
// hpvm::DEVICE is deprecated; do not use.
#ifndef DEVICE
#define DEVICE CUDNN_TARGET
#endif

#include "SupportHPVM/HPVMHint.h"

#ifdef __cplusplus
extern "C" {
void __hpvm__hint(hpvm::Target);
#else
void __hpvm__hint(enum Target);
#endif

void *__hpvm__createNodeND(unsigned, ...);
void __hpvm__return(unsigned, ...);

void __hpvm__attributes(unsigned, ...);
void __hpvm__init();
void __hpvm__cleanup();

void __hpvm__bindIn(void *, unsigned, unsigned, unsigned);
void __hpvm__bindOut(void *, unsigned, unsigned, unsigned);
void *__hpvm__edge(void *, void *, unsigned, unsigned, unsigned, unsigned);
void __hpvm__push(void *, void *);
void *__hpvm__pop(void *);
void *__hpvm__launch(unsigned, ...);
void __hpvm__wait(void *);

void *__hpvm__getNode();
void *__hpvm__getParentNode(void *);
void __hpvm__barrier();
void *__hpvm__malloc(long);
long __hpvm__getNodeInstanceID_x(void *);
long __hpvm__getNodeInstanceID_y(void *);
long __hpvm__getNodeInstanceID_z(void *);
long __hpvm__getNumNodeInstances_x(void *);
long __hpvm__getNumNodeInstances_y(void *);
long __hpvm__getNumNodeInstances_z(void *);

// Atomic
// signed int
int __hpvm__atomic_cmpxchg(int *, int, int);
int __hpvm__atomic_add(int *, int);
int __hpvm__atomic_sub(int *, int);
int __hpvm__atomic_xchg(int *, int);
int __hpvm__atomic_inc(int *);
int __hpvm__atomic_dec(int *);
int __hpvm__atomic_min(int *, int);
int __hpvm__atomic_max(int *, int);
int __hpvm__atomic_umax(int *, int);
int __hpvm__atomic_umin(int *, int);
int __hpvm__atomic_and(int *, int);
int __hpvm__atomic_or(int *, int);
int __hpvm__atomic_xor(int *, int);

// Special Func
float __hpvm__floor(float);
float __hpvm__rsqrt(float);
float __hpvm__sqrt(float);
float __hpvm__sin(float);
float __hpvm__cos(float);

/*
 * ApproxHPVM specific function calls
 */

void *__hpvm__tensor_add(void *, void *);
void *__hpvm__tensor_mul(void *, void *);
void *__hpvm__tensor_convolution(void *, void *, int, int, int, int);
void *__hpvm__tensor_group_convolution(void *, void *, int, int, int, int, int,
                                       int);
void *__hpvm__tensor_batchnorm(void *, void *, void *, void *, void *, double);
void *__hpvm__tensor_pool_max(void *, int, int, int, int, int, int);
void *__hpvm__tensor_pool_mean(void *, int, int, int, int, int, int);
void *__hpvm__tensor_relu(void *);
void *__hpvm__tensor_tanh(void *);
void *__hpvm__tensor_softmax(void *);

// New HPVM intrinsic for Setting Node ID
void *__hpvm__node_id(int);

#include <unistd.h>

long get_global_id(int);
long get_group_id(int);
long get_local_id(int);
long get_local_size(int);

void llvm_hpvm_track_mem(void *, size_t);
void llvm_hpvm_untrack_mem(void *);
void llvm_hpvm_request_mem(void *, size_t);

/*#ifdef __cplusplus
void hpvm_request_tensor(void*, hpvm::Target);
#else
void hpvm_request_tensor(void*, enum Target);
#endif
*/

#ifdef __cplusplus
}
#endif
